#!/usr/bin/env ruby

module LTools
  autoload :Tool,     'core/tool'
  autoload :ToolOpts, 'core/opts'

  autoload :Tshark,   'tools/tshark'
  autoload :Nmap,     'tools/nmap'

  @tools = []

  class << self
    attr_accessor :verbose

    def add_tool(tool)
      @tools << tool
    end

    def check_all?
      @tools.map do |child_class| 
        child_class.check?
      end
    end
  end
end
