
module LTools
  class Nmap < Tool
    @name = 'nmap'

    # TODO 非正常退出的情况, Root权限问题
    def self.portscan(targets, ports: nil, mode: 'S', speed: 5, xml_report: nil, append: nil)
      cmd = "nmap -Pn -n -T#{speed} -s#{mode}"
      cmd << ToolOpts.build {|opts|
        opts.on('-p', ports)
        opts.on('-oX', xml_report){ |file|
          next file unless file == :auto
          @nmap_xml_report = Tempfile.new('ltools-nmap-xml-report')
          @nmap_xml_report.close
          @nmap_xml_report.to_path
        }
      }
      cmd << self.targets_cmd(targets)
      cmd << ' ' << append if append
      new cmd
    end

    def self.targets_cmd(targets)
      case targets
      when Array
        if targets.size < 8
          targets.join ' '
        else
          infile = Tempfile.new('ltools-nmap-')
          infile.puts targets
          infile.close
          "-iL #{infile.to_path}"
        end
      when String
        File.file?(targets) ? "-iL #{targets}" : targets
      end
    end

    def xml_report
      require 'nmap/xml'
      if index = @cmd.index('-oX')
        file = @cmd[index+1]
        ::Nmap::XML.new(file)
      end
    end
  end
end
