
module LTools
  class Tshark < Tool
    @name = 'tshark'

    def self.capture(interface: nil, bpf: nil, fields:nil, filter: nil, append: nil)
      cmd = 'tshark'
      cmd << ToolOpts.build {|opts|
        opts.on('-i', interface)
        opts.on('-f', bpf)
        opts.on('-Y', filter)
      }
      if fields
        fields = fields.split if fields.is_a? String
        fields.unshift ' -T fields'
        cmd << fields.join(' -e ')
      end
      cmd << ' ' << append  if append
      new cmd
    end

    def records
      @stdout.each_line.map do |line|
        line.split("\t")
      end
    end
  end
end
